if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
	{
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	}
		RTB_registerPref("Flood Enabled", "Flood Protection", "$Pref::Server::FloodEnabled", "bool", "Script_ToggleFlood", 3);
} 
else
{
	$Pref::Server::FloodEnabled = 1;
}

if($Pref::Server::FloodEnabled != 0 && $Pref::Server::FloodEnabled != 1)
{
	$Pref::Server::FloodEnabled = 1;
}

package toggleFlood
{
	function spamAlert(%c)
	{
		if ($Pref::Server::FloodEnabled == 0 || %c.isAdmin || %c.isSuperAdmin)
		{
			return false;
		}
		return parent::spamAlert(%c);
	}

	function serverCmdMessageSent(%c, %msg)
	{
		floodProtect(%c);
		Parent::serverCmdMessageSent(%c, %msg);
	}

	function serverCmdTeamMessageSent(%c, %msg)
	{
		floodProtect(%c);
		Parent::serverCmdTeamMessageSent(%c, %msg);
	}

};
activatePackage(toggleFlood);



function floodProtect(%c)
{
	if ($Pref::Server::FloodEnabled == 0 || %c.isSuperAdmin || %c.isAdmin)
	{
		%c.isSpamming = false;
		
		%c.spamMessageCount = "";
		%c.spamProtectStart = "";
		
		%c.lastChatTime = "";
		%c.lastChatText = "";
	}
}



function serverCmdToggleFlood(%c)
{

	if(!%c.isSuperAdmin)
		return;
	
	if($Pref::Server::FloodEnabled == 1)
	{
		echo("Flood protection has been disabled");
		
		messageAll('',"\c0Flood protection has been disabled");
		
		$Pref::Server::FloodEnabled = 0;
	} 
	else 
	{
		echo("Flood protection has been enabled");
		
		messageAll('',"\c2Flood protection has been enabled");
		
		$Pref::Server::FloodEnabled = 1;
	}
	
}